%define _lto_cflags %{nil}
%global qt_module qtdeclarative
%global __provides_exclude_from ^%{_qt5_archdatadir}/qml/.*\\.so$
%if 0%{?bootstrap}
%global no_examples CONFIG-=compile_examples
%endif

Summary: Qt5 - QtDeclarative component
Name:    qt5-%{qt_module}
Version: 5.15.7
Release: 3%{?dist}
License: LGPLv2 with exceptions or GPLv3 with exceptions
Url:     http://www.qt.io
%global majmin %(echo %{version} | cut -d. -f1-2)
Source0: https://download.qt.io/official_releases/qt/%{majmin}/%{version}/submodules/%{qt_module}-everywhere-opensource-src-%{version}.tar.xz
Patch3000: 0001-Document-that-StyledText-also-supports-nbsp-and-quot.patch
Patch3001: 0002-Support-apos-in-styled-text.patch
Patch3002: 0003-Remove-unused-QPointer-QQuickPointerMask.patch
Patch3003: 0004-QQmlDelegateModel-Refresh-the-view-when-a-column-is-.patch
Patch3004: 0005-Fix-sweep-step-for-tainted-QObject-JavaScript-wrappe.patch
Patch3005: 0006-Revert-Fix-for-possible-crash-in-QSGDefaultLayer-gra.patch
Patch3006: 0007-Fix-TapHandler-so-that-it-actually-registers-a-tap.patch
Patch3007: 0008-Revert-Fix-TapHandler-so-that-it-actually-registers-.patch
Patch3008: 0009-QQmlJs-FixedPoolArray-fix-UB-precondition-violation-.patch
Patch3009: 0010-V4-Do-not-call-dtor-of-an-object-we-continue-to-use.patch
Patch3010: 0011-Make-sure-QQuickWidget-and-its-offscreen-window-s-sc.patch
Patch3011: 0012-QQuickItem-Guard-against-cycles-in-nextPrevItemInTab.patch
Patch3012: 0013-QSGOpenGLDistanceFieldGlyphCache-fix-multiplication-.patch
Patch3013: 0014-QSGOpenGLDistanceFieldGlyphCache-fix-UB-ordering-of-.patch
Patch3014: 0015-Fix-Flickable-wheel-velocity-calculation.patch
Patch3015: 0016-Fix-Flickable-with-QTBUG-56075-patch-applied.patch
Patch3016: 0017-Reset-currentChanges-if-currentChanges-is-active-whe.patch
Patch3017: 0018-Revert-Fix-ListView.isCurrentItem-when-used-with-Del.patch
Patch3018: %{name}-gcc11.patch
Patch3019: qtdeclarative-5.15.0-FixMaxXMaxYExtent.patch

BuildRequires: make, gcc-c++, qt5-rpm-macros, python3
BuildRequires: qt5-qtbase-devel >= %{version}, qt5-qtbase-private-devel
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}
%if 0%{?tests}
BuildRequires: dbus-x11, mesa-dri-drivers, time, xorg-x11-server-Xvfb
%endif

%description
%{summary}.

%package devel
Summary: Development files for %{name}
Obsoletes: qt5-qtjsbackend-devel < 5.2.0
Obsoletes: qt5-qtdeclarative-render2d-devel < 5.7.1-10
Provides:  %{name}-private-devel = %{version}-%{release}
Requires: %{name} = %{version}-%{release}
Requires: qt5-qtbase-devel
%description devel
%{summary}.

%package static
Summary: Static library files for %{name}
Requires: %{name}-devel = %{version}-%{release}
%description static
%{summary}.

%package examples
Summary: Programming examples for %{name}
Requires: %{name} = %{version}-%{release}
%description examples
%{summary}.



%prep
%autosetup -n %{qt_module}-everywhere-src-%{version} -p1



%build

ln -s %{__python3} python
export PATH=`pwd`:$PATH

%qmake_qt5

%make_build



%install
%make_install INSTALL_ROOT=%{buildroot}

mkdir %{buildroot}%{_bindir}
pushd %{buildroot}%{_qt5_bindir}
for i in * ; do
  case "${i}" in
    qmlplugindump|qmlprofiler)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt5
      ln -sv ${i} ${i}-qt5
      ;;
    qml|qmlbundle|qmlmin|qmlscene)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt5
      ln -sv ${i} ${i}-qt5
      ;;
    *)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ;;
  esac
done
popd

pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  rm -fv "$(basename ${prl_file} .prl).la"
  sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
done
popd



%check
%if 0%{?tests}
export CTEST_OUTPUT_ON_FAILURE=1
export PATH=%{buildroot}%{_qt5_bindir}:$PATH
export LD_LIBRARY_PATH=%{buildroot}%{_qt5_libdir}
make sub-tests-all %{?_smp_mflags}
xvfb-run -a \
dbus-launch --exit-with-session \
time \
make check -k -C tests ||:
%endif



%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig



%files
%license LICENSE.LGPL*
%{_qt5_libdir}/libQt5Qml.so.5*
%{_qt5_libdir}/libQt5QmlModels.so.5*
%{_qt5_libdir}/libQt5QmlWorkerScript.so.5*
%{_qt5_libdir}/libQt5Quick.so.5*
%{_qt5_libdir}/libQt5QuickWidgets.so.5*
%{_qt5_libdir}/libQt5QuickParticles.so.5*
%{_qt5_libdir}/libQt5QuickShapes.so.5*
%{_qt5_libdir}/libQt5QuickTest.so.5*
%{_qt5_plugindir}/qmltooling/
%{_qt5_archdatadir}/qml/

%files devel
%{_bindir}/qml*
%{_qt5_bindir}/qml*
%{_qt5_headerdir}/Qt*/
%{_qt5_libdir}/libQt5Qml.so
%{_qt5_libdir}/libQt5Qml.prl
%{_qt5_libdir}/libQt5QmlModels.so
%{_qt5_libdir}/libQt5QmlModels.prl
%{_qt5_libdir}/libQt5QmlWorkerScript.so
%{_qt5_libdir}/libQt5QmlWorkerScript.prl
%{_qt5_libdir}/libQt5Quick*.so
%{_qt5_libdir}/libQt5Quick*.prl
%dir %{_qt5_libdir}/cmake/Qt5Quick*/
%{_qt5_libdir}/cmake/Qt5*/Qt5*Config*.cmake
%{_qt5_libdir}/metatypes/qt5*_metatypes.json
%{_qt5_libdir}/pkgconfig/Qt5*.pc
%{_qt5_archdatadir}/mkspecs/modules/*.pri
%{_qt5_archdatadir}/mkspecs/features/*.prf
%dir %{_qt5_libdir}/cmake/Qt5Qml/
%{_qt5_libdir}/cmake/Qt5Qml/Qt5Qml_*Factory.cmake
%{_qt5_libdir}/cmake/Qt5QmlImportScanner/

%files static
%{_qt5_libdir}/libQt5QmlDevTools.a
%{_qt5_libdir}/libQt5QmlDevTools.prl
%{_qt5_libdir}/libQt5PacketProtocol.a
%{_qt5_libdir}/libQt5PacketProtocol.prl
%{_qt5_libdir}/libQt5QmlDebug.a
%{_qt5_libdir}/libQt5QmlDebug.prl

%if ! 0%{?no_examples:1}
%files examples
%{_qt5_examplesdir}/
%endif



%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.7-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.7-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 8 2022 Zhao Zhen <jeremiazhao@tencent.com> - 5.15.7-1
- initial
